#include "includes.h"
#include "menu.h"
#include "read.h"
#include "fill_keyboard.h"
#include "fill_file.h"
using namespace std;

bool c123(int n){return n==1 || n==2 || n==3;}

bool c12(int n){return n==1 || n==2;}

bool testcase(string s){
	return s=="a1i"  ||
	       s=="a1ii" ||
	       s=="a2"   ||
	       s=="a3"   ||
	       s=="a4"   ||
	       s=="a5"   ||
	       s=="a6"   ||
	       s=="a7"   ||
	       s=="a8"   ||
	       s=="a9"   ||
	       s=="a10"  ||

	       s=="b1" ||
	       s=="b2" ||
	       s=="b3" ||
	       s=="b4" ||
	       s=="b5" ||

	       s=="d1" ||
	       s=="d2" ||
	       s=="d3" ||
	       s=="d4" ||
	       s=="d5" ||
	       s=="d6" ||
	       s=="d7" ||

	       s=="stress-test-false"    ||
	       s=="stress-test-true"     ||
	       s=="stress-test-1m-false" ||
	       s=="stress-test-1m-true";
}

void menu(vector<int> &v){
	bool loop;

	do{
		loop=true;

		cout<<"\n1 - Read from file\n";
		cout<<"2 - Read from keyboard\n";
		cout<<"3 - Exit\n";

		int input=read_int("Choose: ","Valid choices are: 1, 2 or 3",c123);
		switch(input){//Read from file
			case 1:{
				loop=submenu(v);
				break;
			}

			case 2:{//Read from keyboard
				fill_keyboard::fill(v);
				loop=ask_again();
				break;
			}

			case 3:{//Exit
				loop=false;
				break;
			}

			default:{
				loop=false;
				break;
			}
		}
	}while(loop);
	cout<<"Goodbye!";
}

bool submenu(vector<int> &v){
	cout<<"\n1 - Read from formatted file\n";
	cout<<"2 - Read from flat file\n";
	cout<<"3 - Testcases\n";
	cout<<"4 - Cancel reading from file\n";


	int input=read_int("Choose: ","Valid choices are: 1, 2 or 3",c123);
	switch(input){
		case 1:{//Read from formatted file
			fill_file::fill_formatted("formatted",v);
			return ask_again();
		}

		case 2:{//Read from flat file
			fill_file::fill_flat("flat",v);
			return ask_again();
		}

		case 3:{//Specify flat file name
			fill_file::fill_flat(read_str("Select testcase: ","Please enter a testcase! (a1i, a1ii, a2, a3, a4, a5, a6, a7, a8, a9, a10, b1, b2, b3, b4, b5, d1, d2, d3, d4, d5, d6, d7, stress-test-false, stress-test-true, stress-test-1m-false, or stress-test-true)",testcase),v);
			return ask_again();
		}

		case 4:{//Cancel reading from file
			return true;
		}

		default:{
			return false;
		}
	}

}

bool ask_again(){
	cout<<"1 - Back to menu\n";
	cout<<"2 - Quit\n";

	int input=read_int("Again? ","Valid choices are: 1 or 2",c12);
	switch(input){
		case 1:{//Back to menu
			return true;
		}

		case 2:{//Quit
			return false;
		}

		default:{
			return false;
		}
	}

}
